/*Welcome to our final JS lesson for the semester! This lesson aims to tie Javascript into the other topics we've covered this semester. Most of this should be familiar, but some of it will feel new. Take your time, and it should be within reach for most of you! */


//These variables allow us to access specific elements within our document by IDs
var enterButton = document.getElementById("enter");
var input = document.getElementById("userInput");

//The Document method querySelector() returns the first Element within the document that matches the specified selector, or group of selectors. (Read more: https://developer.mozilla.org/en-US/docs/Web/API/Document/querySelector)
var ul = document.querySelector("ul");
//So, this line creates a variable that contains the first ul element in our document, which in this case is the empty list we're going to write to.

//Read the documentation here: https://developer.mozilla.org/en-US/docs/Web/API/Document/getElementsByTagName
var item = document.getElementsByTagName("li");
// Here we create a variable that will hold a continually-updated collection of all our to-do lis. Neat, right?

//Simple function that returns the length of what's typed in our input box.
function inputLength() {
	return input.value.length;
} 

//Simple function that returns the number of items in our list.
function listLength() {
	return item.length;
}

//The majority of our functionality resides in this function. 
function createListElement() {
	var li = document.createElement("li"); // creates an element "li"
	li.appendChild(document.createTextNode(input.value)); //makes text from input field the li text
	ul.appendChild(li); //adds li to ul
	input.value = ""; //Reset text input field


	//START STRIKETHROUGH
	// because it's in the function, it only adds it for new items
	function crossOut() {
		li.classList.toggle("done");//This appends the CSS class "done" to the lis when clicked on.
	}

	li.addEventListener("click",crossOut);//An event listener—wait for—listens for an event, in this case a click, upon which our crossOut function is triggered.
	//END STRIKETHROUGH


	// START ADD DELETE BUTTON
	var dBtn = document.createElement("button");//Creates a button element
	dBtn.appendChild(document.createTextNode("XX"));//Gives the button element the text content of X
	li.appendChild(dBtn);//Appends the delete button to an LI
	dBtn.addEventListener("click", deleteListItem);//On click, calls the deleteListItem function we've created below.
	// END ADD DELETE BUTTON


	//ADD CLASS DELETE (DISPLAY: NONE)
	function deleteListItem(){
		li.classList.add("delete")//Adds the class delete to our lis
	}
	//END ADD CLASS DELETE
}


function addListAfterClick(){
	if (inputLength() > 0) { //makes sure that an empty input field doesn't create a li
		createListElement();
	}
}//This function prevents our createListElement function from being called on click if we try to add an empty input field

function addListAfterKeypress(event) {
	if (inputLength() > 0 && event.which ===13) { //this now looks to see if you hit "enter"/"return"
		//the 13 is the enter key's keycode, this could also be display by event.keyCode === 13
		createListElement();
	} 
}//This function prevents our createListElement function from being called on keypress if we try to add an empty input field


enterButton.addEventListener("click",addListAfterClick);//Adds a click listener to our Enter button

input.addEventListener("keypress", addListAfterKeypress);//Adds a keypress listener to our input field

/* Challenges now that you've read through this:
- Change how completed list items are displayed (add a strikethrough, a check mark, etc.)
- Change the max length allowed for list item input
- One of our functions actually isn't used and isn't needed—figure out which one!
- Advanced: make it so that you can press the delete key to delete the most recent list item.
- */